// Main.cpp : main project file.

#include "stdafx.h"
#include "Insert.h"

using namespace System;
//using namespace InsertGameWebService;

#ifdef OFFLINE
void RunMatch(int P,int N,Engine&eng,Engine&engOp,int NRuns=1,int seed=0){
	clock_t start0=clock(),start,finish;
	int totalScore[2];
	totalScore[0]=totalScore[1]=0;
	double maxTime=0.0;
	double times[2],totaltimes[2];
	times[0]=times[1]=totaltimes[0]=totaltimes[1]=0.0;
	srand(seed);
	array<int>^squares=gcnew array<int>(N);
	printf("*******************************************************************************\n");
	printf("Match of %d games. Engines %s:%s, Depth %d:%d, P %d, N %d, seed %d\n",
		NRuns,EngineNames[eng.strat],EngineNames[engOp.strat],eng.depth,engOp.depth,P,N,seed);
	printf("*******************************************************************************\n\n");
	for(int i=0;i<NRuns;i++){
		printf("*******************************************************************************\n");
		printf("Game %d.\n",i+1);
		Game G(P,N);
		for(int i=0;i<G.K;i++)squares[i]=Pictures[i];
		start=clock();
		G.Run(squares,eng,engOp,times);
		finish=clock();
		totaltimes[0]+=times[0];
		totaltimes[1]+=times[1];
		double currTime=((double)finish-(double)start)/CLOCKS_PER_SEC;
		printf("Time passed: %f sec\n",currTime);
		if(currTime>maxTime)maxTime=currTime;
		totalScore[0]+=G.Score[0],totalScore[1]+=G.Score[1];
	}
	printf("\ntotalScore in %d runs %d:%d\n",NRuns,totalScore[0],totalScore[1]);
	printf("Total time passed: %f sec\n",((double)finish-(double)start0)/CLOCKS_PER_SEC);
	printf("Total Times used: %f:%f sec\n",totaltimes[0],totaltimes[1]);
	//printf("MaxTime: %f sec\n",maxTime);
}
#endif

int main(array<System::String^>^args)
{
	int depth=5,depthtimeout=4;
#ifdef TEST
	int depthOp=5;
	int NRuns=10;
#endif
#ifdef OFFLINE
	//Engine eng(EVAL3XX,depth),engOp(EVAL4XX,depthOp);
	//Engine eng(EVAL3XX,depth),engOp(EVAL3XX,depthOp);
	//Engine eng(EVAL4XX,depth),engOp(EVAL4X,depthOp);
	//Engine eng(EVAL4XX,depth),engOp(EVAL5,depthOp);
	Engine eng(EVAL4XX,depth),engOp(EVAL5X,depthOp);

	RunMatch(7,200,eng,engOp,NRuns);
	
#else//ONLINE
	double timepermove=0.17;

	InsertGameWebService::SlideWebService ^service = gcnew InsertGameWebService::SlideWebService();
	//String^username="vladimir.molotkov";
	//String^opusername="";//"vladimir.molotkov2";
	__int64 sessionId;
	array<array<int>^>^board;
	int n;
	array<int>^squares;
  bool isFirst; 
  String^status;
	clock_t start0=clock(),start,totals[2],timeout;
#ifdef TEST
	for(int i=0;i<NRuns;i++){
	printf("*******************************************************************************\n");
	printf("Online %d. Depth %d\n",i+1,depth);
#endif
#ifdef TEST
TRY_AGAIN:
	int res=service->StartGame("vladimir.molotkov2","",sessionId,board,n,squares,isFirst,status);
#else
	int res=service->StartGame("vladimir.molotkov","",sessionId,board,n,squares,isFirst,status);
#endif
	if(res!=0){
#ifdef TEST
		printf("Something wrong with slide web service! Try again...\n");
		goto TRY_AGAIN;
#endif
		return 0;
	}
	start0=clock();
	totals[0]=totals[1]=0;
	timeout=(clock_t)((timepermove*(n/2)*CLOCKS_PER_SEC));
	Game G(board,squares,n,isFirst,0.2);
	int bestmove;
  int opMove,opMovePrev=-1,Nreps=0;
	if(depth>G.K)depth=G.K;
	while(res==0){
		start=clock();
		//int eval,evalOp;
		EVAL eval,evalOp;
		int pic=squares[0],picOp=0;
		if(G.K>1)picOp=squares[1];//Otherwise there is no direct way to determine opponent's picture!
		if(G.K>1){
			int dummyOp=Nreps>MIN_DUMMY?opMovePrev:-1;
			G.currBoard.Eval3XX(bestmove,eval,evalOp,depth,squares,0,dummyOp,true);
			//G.currBoard.Eval(bestmove,eval,evalOp,5,squares,0,dummyOp);
		}
		else eval=G.currBoard.Eval(bestmove,pic,true);
		int deltascore=G.currBoard.MakeMoveX(bestmove,pic);
		G.Score[0]+=deltascore;
#ifdef PRINT_POSITIONS
		printf("%d. Pict %d, Move %d. Eval %d, deltaScore %d, Score %d, Position:\n",G.N++,pic,bestmove,eval.score,deltascore,G.Score[0]);
		G.currBoard.Print();
#endif
		totals[0]+=clock()-start;
		if(totals[0]>timeout&&depth>depthtimeout){
			depth=depthtimeout;
#ifdef TEST
			printf("Timeout!!!\n");
#endif
		}
		start=clock();
    res=service->MakeMove(sessionId,bestmove+1,board,squares,opMove,status);
		totals[1]+=clock()-start;
		if(opMove-1==opMovePrev)Nreps++;
		else Nreps=0;
		opMovePrev=opMove-1;
		if(opMove==0)break;//Web service sends -1 instead of the real last opponent
		if(G.K>1)evalOp=G.currBoard.MakeMoveX(opMove-1,picOp),G.Score[1]+=evalOp.score;
		else G.currBoard=board;
#ifdef PRINT_POSITIONS
		printf("%d. Pict=%d, Move %d. Eval ??, deltaScore %d, Score %d, Position:\n",G.N++,picOp,opMove-1,evalOp.score,G.Score[1]);
		G.currBoard.Print();
#if 1//Check that my MakeMove==server MakeMove
		//if(opMove!=0){
		Board currBoard=board;
		//if(currBoard!=G.currBoard){
		if(currBoard.operator!=(G.currBoard)){
			printf("Bad position! Server says it must be:\n");
			currBoard.Print();
			printf("Heights: ");
			G.currBoard.Height.Print();printf(" ");currBoard.Height.Print();printf("\n");
		}//}
#endif
#endif
	}
#ifdef TEST
	Console::WriteLine(status);
	printf("Score: %d : %d\n",G.Score[0],G.Score[1]);
	printf("Time passed: %f sec\n",((double)clock()-(double)start0)/CLOCKS_PER_SEC);
	printf("Times used: %f:%f sec\n",(double)totals[0]/CLOCKS_PER_SEC,(double)totals[1]/CLOCKS_PER_SEC);
	}
#endif

#endif//OFFLINE
  return 0;
}
